


# variable Started 0

if {![info exists Started]} {variable Started 0}


if {$Started != 0} {

     variable JS ""
     variable LogFlag



     if {$LogFlag == 1} {InsertLog "Last Updated: [clock format [clock seconds] -format "%B %d, %Y %H:%M:%S"]"}

    do_click
    

}

if {$Started == 0} {           ;#  first time load code and define local variables

#
    set Started 1

	variable console { "Nothing Received" }
	variable USBList { }
	variable channelId 0
	variable USB_Selected 0
     	variable file_base "/home/pi/logs"

proc show_variables {} {
}

proc do_GetUSB {} {
	variable USBList
	variable console

	cd /dev
        set rc [catch {exec sudo ls } m]
	if { $rc != 0 }  then {
		InsertLog "Response is to ls $rc : Command returned $m"
		return 
	}
	set USBList {}
	set lslist [ split $m "\n" ]
	foreach item  $lslist {
		set val [ string compare -length 5 $item "ttyUSB" ]

		if { $val == 0 } {
			lappend console "\n"
			lappend console $item
			lappend USBList $item
		}
	}
	set length [ llength $USBList ]
#	InsertLog " Found $length ttyUSB devices"
	
}
  proc do_Connect { } {
	variable channelId
	variable USBList
	variable USB_Selected
	foreach device $USBList {

	  	set port [ file join  "/dev" $device ]
	  	set z [catch {exec sudo -n chmod 666 $port} m]   ;# need rw access to serial port
	  	if {$z != 0} {InsertLog "failed to change access mode to I/O port\n$m"}

	       	set z [catch {open $port RDWR} m]
#		puts stderr "Opening $port returned $z and $m"
	       	if {$z != 0} {
			InsertLog "failed to open access to I/O port\n$m"
		} else {
			set channelId $m
	      		set z [catch {fconfigure $channelId -mode 9600,n,8,1 -handshake none } result ] 
			if { $z != 0 } { puts stderr "fconfigure returned $z\n Result = $result" }
			set z [catch {fconfigure $channelId -blocking 0 -buffering none -translation binary } result ] 
			if { $z != 0 } { puts stderr "fconfigure returned $z\n Result = $result" }
			set z [catch { fileevent $channelId readable  [ list ::Pi_Monitor::GetData $channelId $device] } result ]
			if { $z != 0 } { puts stderr "fileevent returned $z\n Result = $result" }
	#		InsertLog "Connected 1 to $port ok with feeling"
	#		InsertLog "Fileevent returned $result"
		}
	}
}

proc GetData { channel device} {

    variable file_base
    
    set filename [ file join "$file_base" $device ] 
    set z [catch {open $filename a } m]
    if {$z != 0} {puts stderr "failed to open $filename for APPEND => $m"}
    set fileId $m
    set timestrg [ clock format [ clock seconds ] -format "%d/%H:%M:%S|" ]
#	puts stderr "Clock => $timestrg\n"
    set data [read $channel 132]
    for { set i 0 } {$i < [string length $data]} {incr i} {
        set c [string range $data $i $i]
    	set z [catch {puts -nonewline $fileId $c } m]
    	if {$z != 0 } {puts stderr "failed to append data to  $filename => $m"}
	if { $c == "\n" } { puts -nonewline $fileId "$timestrg" }
    }
    flush $fileId
    close $fileId
#    puts stderr "GetData was called for channel $channel!"

}

proc do_Parse {} {
	variable file_base
	variable USBList
	variable console

	set console {} 

	foreach device $USBList {
		set filename [ file join "$file_base" $device ] 
		set z [catch {open $filename r } m]
		if {$z != 0} {InsertLog "failed to open $filename for read => $m"}
		set fileId $m
		set z [catch {read $fileId} m]
		if {$z != 0} {puts stderr "failed to read $filename => $m"}
		set logList [ split $m " " ]
		set list_length [ llength $logList ]
#		InsertLog "Device $device has $list_length words"
		set IPlist [ lsearch -all $logList DHCP ]
		set IP_len [ llength $IPlist ]
		set last [ expr $IP_len - 1 ]
		set ip_place [ expr [ lindex $IPlist $last ]  + 14 ]
		set My_IP [ lindex $logList $ip_place ]
#		InsertLog "$IPlist"
		set ip_place [ expr [ lindex $IPlist $last ]  + 21 ]
		set My_name [ lindex $logList $ip_place ]
		
		set panics [ llength [ lsearch -all $logList panic ] ]

		set last [ lrange $logList [ expr $list_length - 50 ]  end ]
#		set last_list [ split $last "." ]
		set last_search [ llength [ lsearch -all $last custom ] ]
		if { $last_search == 1 } {
			set status "Finished OK"
		} else {
			set status "Not Finished"			
		}
#		InsertLog "Found $IPlist places where DHCP occurs in $device"
#		InsertLog "My IP is  $My_IP\nMy name is $My_name\nLast_search = $last_search"
		lappend console "$device =>  last $My_name => last $My_IP ; #panics => $panics ; $status \n"
	}
}

    proc do_click {} {
	variable cgidata
	variable Started
	variable LogFlag
	variable ShowLogFlag
	variable JS
	variable USB_Selected





	set cgidata [ncgi::nvlist]
	
	if {$LogFlag == 1} {InsertLog "cgidata= ([llength $cgidata]) $cgidata"}
	
	if {[llength $cgidata] == 0} then {return}
	
	if {[llength $cgidata] < 2} then {
	    InsertLog "CGI data is too short: $cgidata"
	} else {
	    if {[lindex $cgidata 0] != "Widget"} then {
		InsertLog "Invalid CGI data: $cgidata"
	    } else {
		
		set w [lindex $cgidata 1]
		set vl [second [lindex $cgidata 1]]
		
		
		switch -glob [lindex $w 0] {
		    
		    RESET    {set Started 0; return}
		    CLEAR    {EmptyLog}
		    ELOG     {PrintLog}
		    RELOAD   {variable Reloading; set Reloading 1}
		    VARIABLES {show_variables}

		    GETUSB    { do_GetUSB }
		    CONUSB    { do_Connect }
		    PARSE    { do_Parse }
		    TTYSEL    { set USB_Selected $vl }

		    HIDE     {set ShowLogFlag 0}
		    SHOW     {set ShowLogFlag 1}
		    LOGON    {set LogFlag 1}
		    LOGOFF   {set LogFlag 0}
		    
		    HELP     {
			variable HelpTopic
			set HelpTopic $vl
			do_help
		    }
		    undefined {}
		    default {InsertLog "unexpected CGI data: [lindex $w 0]: $cgidata" }
		}
	    }
	}
    }
    set html ""

}   ;# end of if {$Started == 0}



