

#    experiment run control for AIDA - taken from sys.tcl

global MIDAS_DataAcquisitionControlServer_Verbose
set MIDAS_DataAcquisitionControlServer_Verbose 0

global env

global Options

variable MaxASICs 4
variable MaxChans 16

#variable MaxLocations 

variable SpecBase [file join $env(MIDASBASE) SpecData AIDA]
variable SpecPath


proc Dump_Raw_Data {} {return "[Dump_Raw_Aida_ASIC_Data]\n[Dump_Raw_Aida_WAVE_Data]"}

proc Dump_Raw_GREAT_Data {} { return "[Dump_Raw_GREAT_format]\n[Dump_Raw_Aida_WAVE_Data]"}

proc Set_Options {} {
   global Options

   LoadOptions

   if {![info exists Options(Aida_GroupBase)]} {set Options(Aida_GroupBase) 1}
   if {![info exists Options(Include.Aida)]} {set Options(Include.Aida) 1}

   if {![info exists Options(Rate.channels)]} {set Options(Rate.channels) 150}
   if {![info exists Options(Stat.channels)]} {set Options(Stat.channels) 150}
   if {![info exists Options(Stat.shift)]} {set Options(Stat.shift) 6}
   if {![info exists Options(Stat.offset)]} {set Options(Stat.offset) 64}

   if {![info exists Options(Aida_Hist_L_Enable)]} {set Options(Aida_Hist_L_Enable) 1}
   if {![info exists Options(Aida_Hist_H_Enable)]} {set Options(Aida_Hist_H_Enable) 0}
   if {![info exists Options(Aida_Hist_D_Enable)]} {set Options(Aida_Hist_D_Enable) 1}
   if {![info exists Options(Aida_Hist_W_Enable)]} {set Options(Aida_Hist_W_Enable) 0}
   if {![info exists Options(Aida_Hist_V_Enable)]} {set Options(Aida_Hist_V_Enable) 0}

   if {![info exists Options(Aida.channels)]} {set Options(Aida.channels) 32768}
   if {![info exists Options(Aida.offset)]} {set Options(Aida.offset) 0}
   if {![info exists Options(Aida.shift)]} {set Options(Aida.shift) 1}

   if {![info exists Options(Aida.Wchannels)]} {set Options(Aida.Wchannels) 1020}

   if {![info exists Options(Aida.Vchannels)]} {set Options(Aida.Vchannels) 256}

   if {![info exists Options(ASIC.settings)]} {set Options(ASIC.settings) undefined}

   if {![info exists Options(ExtClk)]} {set Options(ExtClk) 1}

   if {![info exists Options(ASIC_DMA_HWM)]} {set Options(ASIC_DMA_HWM) 0x000fffff}
   if {![info exists Options(WAVE_DMA_HWM)]} {set Options(WAVE_DMA_HWM) 0x0007ffff}
   if {![info exists Options(TS_SYNC_PHASE)]} {set Options(TS_SYNC_PHASE) 1}
   if {![info exists Options(MACB_TRIG_MODE)]} {set Options(MACB_TRIG_MODE) 14}

   if {![info exists Options(DataAcqPgm)]} {set Options(DataAcqPgm) AidaExecV9} 
   if {![info exists Options(DataFormat)]} {set Options(DataFormat) AIDA }

   SaveOptions

}


proc Dump_Raw_Aida_ASIC_Data {} {

   set info "ASIC data $::DataAcquisition::ACQSERVER\n"

   for {set offset 0} {$offset <= 500} {incr offset 100} {

     DataAcqCommand 19 "Getting Raw Data" "17 $offset" 2
     set data [ReadNetVar NetVar.EXEC.Response]

        append info "[llength $data] words"

	set c 0

   set T0027 *
   set T2847 *
   set T4863 *
	
	for {set i 0} {$i < [llength $data]} {incr i} {
	    set word [lindex $data $i]
	    if {$word == 0xaa5555aa} then {
		append info "\n$word - end of dump\n"
		break
	    }
	    if {$word == 0x55aaaa55} then {
		append info "\n$word - end of event\n"
		continue
	    }
	    if {[expr ($word >> 30) & 3] == 3} {
		incr i

		set t [lindex $data $i]; set T0027 $t
		set range [expr ($word >> 28) & 1]
		set id [expr ($word >> 22) & 0x3f]
		set chan [expr ($word >> 16) & 63]
		set adc [format "0x%x" [expr $word & 0xffff]]
		append info "\nADC Item $word $t; Range=$range; ID=$id; Channel=$chan; ADC=$adc; Time (28:47)=$T2847; Time (0:27)=$t"
	    }
	    if {[expr ($word >> 30) & 3] == 2} {
              set valid 0
	      if {[expr ($word >> 20) & 15] == 2} {
		incr i
		set t [lindex $data $i]; set T0027 $t
		set time [format "0x%x" [expr $word & 0x000fffff]]; set T2847 $time
		append info "\nPause Item $word $t; Time (28:47)=$time; Time (0:27)=$t"
                set valid 1
              }
	      if {[expr ($word >> 20) & 15] == 3} {
		incr i
		set t [lindex $data $i]; set T0027 $t
		set time [format "0x%x" [expr $word & 0x000fffff]]; set T2847 $time
		append info "\nResume Item $word $t; Time (28:47)=$time; Time (0:27)=$t"
                set valid 1
              }
	      if {[expr ($word >> 20) & 15] == 4} {
		incr i
		set t [lindex $data $i]; set T0027 $t
		set time [format "0x%x" [expr $word & 0x000fffff]]; set T2847 $time
		append info "\nWR Time Item $word $t; Time (28:47)=$time; Time (0:27)=$t"
                set valid 1
              }
	      if {[expr ($word >> 20) & 15] == 5} {
		incr i
		set t [lindex $data $i]; set T0027 $t
		set time [format "0x%x" [expr $word & 0x000fffff]]; set T4863 $time
		append info "\nWR Time Item $word $t; Time (48:63)=$time; Time (28:47)=$T2847; Time (0:27)=$t"
                set valid 1
              }
	      if {[expr ($word >> 20) & 15] == 6} {
		incr i
		set t [lindex $data $i]; set T0027 $t
		set dat [format "0x%x" [expr $word & 0x000fffff]]
		append info "\nDiscriminator $word $t; Data=$dat; Time (28:47)=$T2847; Time (0:27)=$t"
                set valid 1
              }
	      if {[expr ($word >> 20) & 15] == 8} {
		incr i
		set t [lindex $data $i]; set T0027 $t
		set dat [format "0x%x" [expr $word & 0x000fffff]]
		append info "\nCorrelation Scaler $word $t; Data=$dat; Time (28:47)=$T2847; Time (28:47)=$t"
                set valid 1
              }
              if {$valid == 0} {
	  	 incr i
	 	 set t [lindex $data $i]
		 set dat [format "0x%x" [expr $word & 0x000fffff]]
                 append info "\nUnexpected Info $word $t"
              }
	    }

	    if {[expr ($word >> 30) & 3] == 0} {
		append info "\nDebug Item $word"
	    }
	    
	    incr c
	    
	    if {$c == 10} then {append info "\n"; set c 0}
	}

   }

   return "$info"
}

proc Dump_Raw_GREAT_format {} {

   set info "GREAT format data $::DataAcquisition::ACQSERVER\n"

   for {set offset 0} {$offset <= 300} {incr offset 100} {

     DataAcqCommand 19 "Getting Raw Data" "17 $offset" 2
     set data [ReadNetVar NetVar.EXEC.Response]
     set c 0
	for {set i 0} {$i < [llength $data]} {incr i} {
	    set word [lindex $data $i]
	    if {$word == 0xaa5555aa} then {
		append info "\n$word - end of dump\n"
		break
	    }
	    if {$word == 0x55aaaa55} then {
		append info "\n$word - end of event\n"
		continue
	    }
	    if {[expr ($word >> 30) & 3] == 3} {
		incr i
		set t [lindex $data $i]
		set range [expr ($word >> 29) & 1]
		set chan [expr ($word >> 16) & 15]
		set asic [expr ($word >> 20) & 3]
		set id [expr ($word >> 22) & 0x3f]
		set adc [format "0x%x" [expr $word & 0x0000ffff]]
		append info "\nData Item $word $t; Range=$range; ID=$id; ASIC=$asic; Channel=$chan; ADC=$adc; Time=$t"
	    }
	    
	    if {[expr ($word >> 30) & 3] == 2} {
	      if {[expr ($word >> 20) & 15] == 2 } {
		incr i
		set t [lindex $data $i]
		set time [format "0x%x" [expr $word & 0x000fffff]]
		append info "\nPause Time Item $word $t; Time (high)=$time; Time (low)=$t"
              }
	      if {[expr ($word >> 20) & 15] == 3 } {
		incr i
		set t [lindex $data $i]
		set time [format "0x%x" [expr $word & 0x000fffff]]
		append info "\nResume Time Item $word $t; Time (high)=$time; Time (low)=$t"
              }
	      if {[expr ($word >> 20) & 15] == 4 } {
		incr i
		set t [lindex $data $i]
		set time [format "0x%x" [expr $word & 0x000fffff]]
		append info "\nSYNC Time Item $word $t; Time (high)=$time; Time (low)=$t"
              }
	      if {[expr ($word >> 20) & 15] == 5 } {
		incr i
		set t [lindex $data $i]
		set time [format "0x%x" [expr $word & 0x000fffff]]
		append info "\nGWR Extension Time Item $word $t; Time (high)=$time; Time (low)=$t"
              }
	      if {[expr ($word >> 20) & 15] == 6 } {
		incr i
		set t [lindex $data $i]
		set ch [format "0x%x" [expr $word & 0x0000ffff]]
		append info "\nDiscriminator Item $word $t; channel=$ch; Time (low)=$t"
              }
	      if {[expr ($word >> 20) & 15] == 8} {
		incr i
		set t [lindex $data $i]
		set time [format "0x%x" [expr $word & 0x000fffff]]
		append info "\nCorrelation Event $word $t; Time (high)=$time; Time (low)=$t"
              }
	    } else {
		append info"\nDebug Info item $word"
	    }

	    if {[expr ($word >> 30) & 3] == 0} {
		append info "\nDebug Data Item $word"
	    }
	    
	    incr c
	    
	    if {$c == 10} then {append info "\n"; set c 0}
	} ;# end of data for loop
 
   } ;# end of get data for loop

   return "$info"
}


proc Dump_Raw_Aida_WAVE_Data {} {

   set info "WAVE data $::DataAcquisition::ACQSERVER\n"

   for {set offset 0} {$offset <= 500} {incr offset 100} {

     DataAcqCommand 19 "Getting Raw Data" "18 $offset" 2
     set data [ReadNetVar NetVar.EXEC.Response]

     set c 0

     foreach word $data {
         set word $word
         if {$word == 0xaa5555aa} then {
             append info "\n$word - end of dump\n"
             break
         }
         if {$word == 0x55aaaa55} then {
             append info "\n$word - end of event\n"
             continue
         }
         append info "$word "
         incr c

         if {$c == 10} then {append info "\n"; set c 0}
     }
   }

   return "$info"
}

proc create_Aida_spectra {} {
   variable MaxASICs
   variable MaxChans
   variable MemoryUsed

   global Options

   set Me $::DataAcquisition::ACQSERVER
   set MemoryUsed 0
     puts "Creating spectra for $Me"

    set Options(Aida_Hist_W_Enable) [ReadNetVar NetVar.DACQ.Cwaveenable]

#   for the data channels

   for {set Det 1} {$Det <= $MaxASICs} {incr Det} {

      puts "Creating spectra for ASIC $Det"

      for {set Ch 0} {$Ch < $MaxChans} {incr Ch} {

        if {$Options(Aida_Hist_L_Enable) == 1} {

        set z [catch {CreateSpectrum1D $Det.$Ch.L $Options(Aida.channels)} m]

#    Allow "Spectrum already exists" so that further spectra can be created
         if {$z!=0 && $m==0x30004} then {set z 0}
         if {$z!=0} then {
            puts "Error attempting to create spectrum $Det.$Ch.L"
            error $m
         }

        set z [catch {SpectrumPutTitle $Det.$Ch.L [set Me]_$Det.$Ch.L} m]

        incr MemoryUsed $Options(Aida.channels)

         }

        if {$Options(Aida_Hist_H_Enable) == 1} {

        set z [catch {CreateSpectrum1D $Det.$Ch.H $Options(Aida.channels)} m]

#    Allow "Spectrum already exists" so that further spectra can be created
         if {$z!=0 && $m==0x30004} then {set z 0}
         if {$z!=0} then {
            puts "Error attempting to create spectrum $Det.$Ch.H"
            error $m
         }

        set z [catch {SpectrumPutTitle $Det.$Ch.H [set Me]_$Det.$Ch.H} m]

        incr MemoryUsed $Options(Aida.channels)

         }

        if {$Options(Aida_Hist_W_Enable) == 1} {

        set z [catch {CreateSpectrum1D $Det.$Ch.W $Options(Aida.Wchannels)} m]

#    Allow "Spectrum already exists" so that further spectra can be created
         if {$z!=0 && $m==0x30004} then {set z 0}
         if {$z!=0} then {
            puts "Error attempting to create spectrum $Det.$Ch.W"
            error $m
         }

        set z [catch {SpectrumPutTitle $Det.$Ch.W [set Me]_$Det.$Ch.W} m]

        incr MemoryUsed $Options(Aida.Vchannels)

         }
        if {$Options(Aida_Hist_V_Enable) == 1} {

        set z [catch {CreateSpectrum1D $Det.$Ch.V $Options(Aida.Vchannels)} m]
#    Allow "Spectrum already exists" so that further spectra can be created
         if {$z!=0 && $m==0x30004} then {set z 0}
         if {$z!=0} then {
            puts "Error attempting to create spectrum $Det.$Ch.V"
            error $m
         }

        set z [catch {SpectrumPutTitle $Det.$Ch.V [set Me]_$Det.$Ch.V} m]

        incr MemoryUsed $Options(Aida.Vchannels)

         }

     }
   }

#  for the discriminator data (hit) and its rate 

        if {$Options(Aida_Hist_D_Enable) == 1} {

        set z [catch {CreateSpectrum1D Hit 64} m]

#    Allow "Spectrum already exists" so that further spectra can be created
         if {$z!=0 && $m==0x30004} then {set z 0}
         if {$z!=0} then {
            puts "Error attempting to create spectrum Hit"
            error $m
         }

        set z [catch {SpectrumPutTitle Hit [set Me]_Hit} m]

        incr MemoryUsed 64


        set z [catch {CreateSpectrum1D HitRate 64} m]

#    Allow "Spectrum already exists" so that further spectra can be created
         if {$z!=0 && $m==0x30004} then {set z 0}
         if {$z!=0} then {
            puts "Error attempting to create spectrum HitRate"
            error $m
         }

        set z [catch {SpectrumPutTitle HitRate [set Me]_HitRate} m]

        incr MemoryUsed 64

	puts "Memory Used by Spectra is $MemoryUsed Locations"

        }
}

proc map_Aida_spectra {} {
   global env 
   variable MaxASICs 
   variable MaxChans
   global Options
   upvar #0 SpectraHandle f

   set Me $::DataAcquisition::ACQSERVER

   set SpectraDefs [file join $env(MIDASTempDir) SpectraDefs.dat]

      set z [catch {open $SpectraDefs w} f]
      if {$z != 0} then {
          puts "Cannot open file $SpectraDefs $f"
          return
      }

      map_spectrum "Stat 0 0 0 $Options(Stat.shift)" 

#   for the data channels

   for {set Det 1} {$Det <= $MaxASICs} {incr Det} {

     for {set Ch 0} {$Ch < $MaxChans} {incr Ch} {

       if {$Options(Aida_Hist_L_Enable) == 1} {

       set group [expr $Options(Aida_GroupBase)+(($Det-1)*32)+$Ch]
       set item 0
       map_spectrum "$Det.$Ch.L $group $item $Options(Aida.offset) $Options(Aida.shift)"
       }

       if {$Options(Aida_Hist_H_Enable) ==1} {

       set group [expr $Options(Aida_GroupBase)+(($Det-1)*32)+16+$Ch]
       set item 0
       map_spectrum "$Det.$Ch.H $group $item $Options(Aida.offset) $Options(Aida.shift)"
       }

       if {$Options(Aida_Hist_W_Enable) ==1} {

       set group [expr $Options(Aida_GroupBase)+256+(($Det-1)*16)+$Ch]
       set item 0
       map_spectrum "$Det.$Ch.W $group $item 0 0"
       }

       if {$Options(Aida_Hist_V_Enable) ==1} {

       set group [expr $Options(Aida_GroupBase)+150+(($Det-1)*16)+$Ch]
       set item 0
       map_spectrum "$Det.$Ch.V $group $item 0 0"
       }
     }
   }

   if {$Options(Aida_Hist_D_Enable) == 1} {
        map_spectrum "Hit [expr $Options(Aida_GroupBase)+128] 0 0 0"
   }

   close $f
}

proc doSetUp {} {
    global Options

puts "executing doSetUp for AIDA"

     Set_Options; make-UIregisters

     DataAcqCommand 1 "Halt"

     unmap_spectra

     delete_spectra

      set Me $::DataAcquisition::ACQSERVER

      CreateSpectrum1D Stat $Options(Stat.channels)
      set z [catch {SpectrumPutTitle Stat [set Me]_Stat} m]

      CreateSpectrum1D Rate $Options(Rate.channels)
      set z [catch {SpectrumPutTitle Rate [set Me]_Rate} m]

    create_Aida_spectra

    map_Aida_spectra 

    map_spectra

    Setup_Electronics

    ParameterRestore $Options(ASIC.settings)

    if {[set ::AIDA::TestMode] == 0} {CalibrateADCs} else {puts "Calibrate skipped in test mode"}

    DataAcqCommand 3 "Setup"

    WriteNetVar NetVar.DACQ.PollTicks 100
    WriteNetVar NetVar.DACQ.Crdoutenable 1   ;# enable data readout

    puts "completed doSetUp"

}

   proc ParameterRestore {vl} {

       set fname [file join / tmp RestoreState.log]
       set z [catch {open $fname w} fid]
       if {$z != 0} {puts "Settings Restore logfile not created\n$fid\n"}

        puts "Restoring Settings"
        puts $fid "Restoring Settings at [clock format [clock seconds] -format "%B %d, %Y %H:%M:%S"]"

      set ::AIDA::DBNodeBase $vl
      set ::AIDA::DBNodeName $::DataAcquisition::ACQSERVER
      
      puts $fid "Restoring FEE64 settings from $::AIDA::DBRootName/$::AIDA::DBNodeBase for $::DataAcquisition::ACQSERVER"
      puts "Restoring FEE64 settings from $::AIDA::DBRootName/$::AIDA::DBNodeBase for $::DataAcquisition::ACQSERVER"
 
#    first restore ASIC settings

      for {set asic 1} {$asic < 5} {incr asic} {
         for {set i 0} {$i < 27} {incr i} {
            set vl [DBGetValue ASIC.$asic.$i]
            WriteAIDARegister [expr 0x4000 + (($asic-1)*64) + $i] $vl
         }
      }
      puts $fid "Restored ASIC settings"
# now repeat the load three times to help clear out inactive channels

     for {set asic 1} {$asic <= 4} {incr asic} {
         WriteAIDARegister [expr 0x4000 + (($asic-1)*64) + 28] 0   ;#  load control registers
      }

    for {set asic 1} {$asic <= 4} {incr asic} {
         WriteAIDARegister [expr 0x4000 + (($asic-1)*64) + 28] 0   ;#  load control registers
      }
 
   for {set asic 1} {$asic <= 4} {incr asic} {
         WriteAIDARegister [expr 0x4000 + (($asic-1)*64) + 28] 0   ;#  load control registers
      }
	puts $fid "Operated Load ASIC settings for all four ASICs"
	puts "Operated Load ASIC settings for all four ASICs 3 times"

#    next LED settings

     for {set i 0} {$i < 10} {incr i} {

        set vl [DBGetValue LED.$i]
        WriteAIDARegister [expr 0x900 + $i] $vl
     }

     puts $fid "Restored LED settings"

#    next WAVEform options

     for {set i 0} {$i < 4} {incr i} {

        set vl [DBGetValue WAVE.$i]
        WriteAIDARegister [expr 0x910 + $i] $vl
     }

     puts $fid "Restored WAVEform settings"

#    next DISC settings

     for {set i 6} {$i <= 7} {incr i} {

        set vl [DBGetValue DISC.$i]
        WriteAIDARegister [expr 0x500 + $i] $vl
     }

     puts $fid "Restored DISC settings"

     puts $fid "FEE64 settings restored from $::AIDA::DBRootName/$::AIDA::DBNodeBase for $::DataAcquisition::ACQSERVER"
     puts $fid "Restored Settings at [clock format [clock seconds] -format "%B %d, %Y %H:%M:%S"]"
     puts $fid "#####finished"


#       ::AIDA::WriteRegister HasBeenRestored 1

#        Elog INFORMATION "FEE64 settings restored from $::AIDA::DBRootName/$::AIDA::DBNodeBase for $::DataAcquisition::ACQSERVER"

      puts "Restored FEE64 settings from $::AIDA::DBRootName/$::AIDA::DBNodeBase for $::DataAcquisition::ACQSERVER"

     close $fid

   }

   proc ParameterSave {vl} {

       set fname [file join / tmp SaveState.log]
       set z [catch {open $fname w} fid]
       if {$z != 0} {puts "Settings Save logfile not created\n$fid\n"}

        puts "Saving Settings"
        puts $fid "Saving Settings at [clock format [clock seconds] -format "%B %d, %Y %H:%M:%S"]"


      set ::AIDA::DBNodeBase $vl
      set ::AIDA::DBNodeName $::DataAcquisition::ACQSERVER
      
      puts $fid "Saving FEE64 settings to $::AIDA::DBRootName/$::AIDA::DBNodeBase for $::DataAcquisition::ACQSERVER"

#    first save ASIC settings

      for {set asic 1} {$asic < 5} {incr asic} {
         for {set i 0} {$i < 27} {incr i} {
            set vl [ReadAIDARegister [expr 0x4000 + (($asic-1)*64) + $i]]
            DBSetValue ASIC.$asic.$i [format "0x%02x" [expr $vl & 255]]
         }
      }

     puts $fid "Saved ASIC settings"

#    next LED settings

     for {set i 0} {$i < 10} {incr i} {

        set vl [ReadAIDARegister [expr 0x900 + $i]]
        DBSetValue LED.$i [format "0x%08x" $vl]
     }

     puts $fid "Saved LED settings"

#    next DISC settings

     for {set i 6} {$i <= 7} {incr i} {

        set vl [ReadAIDARegister [expr 0x500 + $i]]
        DBSetValue DISC.$i [format "0x%08x" $vl]
     }

     puts $fid "Saved DISC settings"


#    finally WAVEform options

     for {set i 0} {$i < 4} {incr i} {

        set vl [ReadAIDARegister [expr 0x910 + $i]]
        DBSetValue WAVE.$i [format "0x%08x" $vl]
     }

     puts $fid "Saved WAVEform settings"

     puts $fid "FEE64 settings saved to $::AIDA::DBRootName/$::AIDA::DBNodeBase for $::DataAcquisition::ACQSERVER"
     puts $fid "Saved Settings at [clock format [clock seconds] -format "%B %d, %Y %H:%M:%S"]"
     puts $fid "#####finished"

#       ::AIDA::WriteRegister HasBeenRestored 1

#        Elog INFORMATION "FEE64 settings saved to $::AIDA::DBRootName/$::AIDA::DBNodeBase for $::DataAcquisition::ACQSERVER"

        close $fid

   }

   proc CalibrateADCs {} {

       set Cal(Control) 0x800 
       set Cal(Status) 0x803
       set Cal(BitAlign) 0x802
       set Cal(WordAlign) 0x804

         for {set adc 0} {$adc <= 7} {incr adc} {
        
              WriteAD9252Register $adc 0x0d 0x48 ; # set for calibrate pattern
              WriteAD9252Register $adc 0xff 1   ;# device update
	      set val [ReadAD9252Register $adc 0xd ]
	      if { $val == 0x48 } {
		puts "Pattern selected for ADC $adc ok"
	      } else {
		puts "Pattern select failed for ADC $adc. Got $val not 0x48"
	      }
          }

  	  after 25 ;# try and see if a slow here helps
	  WriteAIDARegister $Cal(Control) 0
	  set val [ReadAIDARegister $Cal(Status)]
	  puts " Status #1 : $val "
	  WriteAIDARegister $Cal(Control) 8
	  set val [ReadAIDARegister $Cal(Status)]
	  puts " Status #2 : $val "
	  WriteAIDARegister $Cal(Control) 9
	  after 25 ; # here too
	  set val [ReadAIDARegister $Cal(BitAlign)]
	  puts " Bit Align result : $val "
	  set val [ReadAIDARegister $Cal(WordAlign)]
	  puts " Word Align result : $val "
          for {set i 0} {$i < 5} {incr i} {
	      set val [ReadAIDARegister $Cal(Status)]
              if {$val == 0xf7} {break}
              after 25    ;#  wait a bit more
          }
	  if {$val == 0xf7} {
              puts "ADCs Calibrated. " 
	  } else {
	      puts "Warning : Status is : $val not 0xF7 "
	      puts " ADCs NOT Calibrated. Check they are set for Calibrate pattern"
	  }

          for {set adc 0} {$adc <= 7} {incr adc} {
             WriteAD9252Register $adc 0x0d 0 ; # set for data output
             WriteAD9252Register $adc 0xff 1   ;# device update
          }

  }

   proc ExtCLK {  } {
	set FW_text "V7"
	set Clock_source "MACB"
        set fw_string [ReadAIDARegister [expr 0x000 + 10]]
	if { ( ( $fw_string >> 24 ) & 0xff ) == 0x38 } {
		set d1 [ expr ( ( $fw_string >> 8 ) & 0xf ) ]
		set d2 [ expr  ( $fw_string  & 0xf ) ]
		set FW_text "V8.$d1$d2"
	} else {
		if { (( $fw_string >> 24 ) & 0xff ) == 0x49 } {
			set d1 [ expr ( ( $fw_string >> 8 ) & 0xf ) ]
			set d2 [ expr  ( $fw_string  & 0xf ) ]
			if { $d1 >= 5 } { set Clock_source "White Rabbit" }
			set FW_text "ISOL.$d1$d2"
		}
	}

#          WriteAIDARegister [expr 0x000 + 5] 0x20    ;#  reset  DCM
          if { $Clock_source == "White Rabbit" } {
		WriteAIDARegister [expr 0x000 + 5] 0x1b    ;#  select clock from external 200MHz with divide
	  } else {
 		WriteAIDARegister [expr 0x000 + 5] 0x0b    ;#  select clock from HDMI
	  }
          set status [ReadAIDARegister  [expr 0x000 + 1] ]        ;#  status
          if {[expr $status] != 0xF} {puts "Clock not locked. status = $status"}
   }

   proc IntCLK {} {

#          WriteAIDARegister [expr 0x000 + 5] 0x20    ;#  reset  DCM
          WriteAIDARegister [expr 0x000 + 5] 0x7    ;#  select internal clock
          set status [ReadAIDARegister  [expr 0x000 + 1] ]        ;#  status
          if {[expr $status] != 0xF} {puts "Clock not locked. status = $status"}
   }


proc Reset_Electronics {} {    ;#   used by RESET

#     WriteAIDARegister 0x400 0   	 ;#   disable Timestamp counter
     WriteAIDARegister 0x300 0x4000   ;#    unset enable readout and reset 

     WriteAIDARegister 0x600 0        ;#  clear DMA
     WriteAIDARegister 0x600 0x8000   ;#  set reset DMA
     WriteAIDARegister 0x600 0        ;#  and clear
}

proc Setup_Electronics {} {    ;#   used by SETUP
    global Options
	set FW_text "V7"

    set Me $::DataAcquisition::ACQSERVER
    set TSMaster $::AIDA::TSMaster
	
    set Clock_source "MACB"

    set fw_string [ReadAIDARegister [expr 0x000 + 10]]
	if { ( ( $fw_string >> 24 ) & 0xff ) == 0x38 } {
		set d1 [ expr ( ( $fw_string >> 8 ) & 0xf ) ]
		set d2 [ expr  ( $fw_string  & 0xf ) ]
		set FW_text "V8.$d1$d2"
	} else {
		if { (( $fw_string >> 24 ) & 0xff ) == 0x49 } {
			set d1 [ expr ( ( $fw_string >> 8 ) & 0xf ) ]
			set d2 [ expr  ( $fw_string  & 0xf ) ]
			if { $d1 >= 5 } { set Clock_source "White Rabbit" }
			set FW_text "ISOL.$d1$d2"
		}
	}

puts "Running Setup_Electronics for $Me with TSMaster $TSMaster. VHDL version $FW_text. Clock source is $Clock_source"

	WriteAIDARegister [expr 0x900 + 12 ]  1	;# stop the wave form discriminators generating triggers

    WriteAIDARegister 0x000 3

    if {$Options(ExtClk) == 0} {IntCLK} else {ExtCLK }

    if {$Me == $TSMaster} {    
	WriteAIDARegister 7 3 ;# set MBS clock for loopback and enable MBS
    } else {
	WriteAIDARegister 7 0 ;# set MBS signals as input
    }

    WriteAIDARegister 0x315 0x180    ;#  MBS triggger delay
    WriteAIDARegister 0x307 0        ;# disable readout for all four of the ASICs Added new control button in runcontrol.

     WriteAIDARegister 8 0 ;# initial setup to enable SYNC return path
     WriteAIDARegister 3 $Options(MACB_TRIG_MODE) ;# connects the OR of the four OR16 signals to the Trigger path to the MACB

     WriteAIDARegister 0x500 0   ;#    unset enable DISCRIMINATOR readout
     if { $Clock_source == "White Rabbit" } {
	     WriteAIDARegister 0x400 0x81 ;#  reset the White Rabbit
	     WriteAIDARegister 0x40e 0x0e ;#  set SYNC rollover target
	     WriteAIDARegister 0x400 0x1 ;#  remove the reset
      } else {
	     WriteAIDARegister 0x400 0   ;#   disable Timestamp counter
	     WriteAIDARegister 0x410 0   ;#   disable Master Timestamp counter
	     WriteAIDARegister 0x416 0   ;#   set Timestamp high 32 bits
	     WriteAIDARegister 0x415 0   ;#   set Timestamp low 32 bits and load timestamp counter
	     WriteAIDARegister 0x400 1   ;#   enable Timestamp counter
      }


     if {$Me == $TSMaster} { 
	WriteAIDARegister 0x410 1   ;#   enable Master timestamp
	WriteAIDARegister 0x40c 2   ;#	 reset the dcm for sync phase control
	WriteAIDARegister 0x40c 0   ;#   and revert to normal
puts "Setting register 0x419"
	WriteAIDARegister 0x419 $Options(TS_SYNC_PHASE)   ;#	 set the SYNC phase to be +90 for two layers of MACB
     }

#     WriteAIDARegister 0x300 0x10000	;# enable the ASIC clock synchronisation
#	after 10 			;# allow time for several sync pulses
#     WriteAIDARegister 0x300 0		;# remove the enable the ASIC clock synchronisation

     WriteAIDARegister 0x603 0x07000000  ;# set ASIC DMA MEM_Base
     WriteAIDARegister 0x604 $Options(ASIC_DMA_HWM)  ;# set ASIC DMA HWM
     WriteAIDARegister 0x609 0x00200000  ;# set ASIC DMA Mem_Size

     WriteAIDARegister 0x70a 0x00200000  ;# set source select
     WriteAIDARegister 0x703 0x07400000  ;# set WAVE DMA MEM_Base
     WriteAIDARegister 0x704 $Options(WAVE_DMA_HWM)  ;# set WAVE DMA HWM
     WriteAIDARegister 0x709 0x00100000  ;# set WAVE DMA Mem_Size

puts "Finished Setup_Electronics for AIDA"

}

proc Stop_Electronics {} {
     WriteAIDARegister [expr 0x900 + 12 ]  1	;# stop the wave form discriminators generating triggers
     WriteAIDARegister 0x300 0   ;#    unset enable ASIC readout
     WriteAIDARegister 0xa00 0   ;#    unset enable WAVE readout
     WriteAIDARegister 0x310 0   ;#    unset enable MBS

     WriteAIDARegister 0x500 0   ;#    unset enable DISCRIMINATOR readout
     WriteAIDARegister 0x307 0   ;#    unset enable ASIC readout

     WriteAIDARegister 0x600 0x8000   ;#  set reset ASIC DMA
     WriteAIDARegister 0x600 0        ;#  and clear

     WriteAIDARegister 0x700 0x8000   ;#  set reset WAVE DMA
     WriteAIDARegister 0x700 0        ;#  and clear
}

proc Go_Electronics {} {

    set Me $::DataAcquisition::ACQSERVER
    set TSMaster $::AIDA::TSMaster

puts "Running Go_Electronics for $Me with TSMaster $TSMaster"
     WriteAIDARegister [expr 0x900 + 12 ]  1	;# stop the wave form discriminators generating triggers

     WriteAIDARegister 0x300 0x4000   ;#  set RDO_reset
     WriteAIDARegister 0x300 0x0000   ;#  unset RDO_reset

     WriteAIDARegister 0x600 0x8000   ;#  set reset ASIC DMA
     WriteAIDARegister 0x600 0        ;#  and clear

     WriteAIDARegister 0x700 0x8000   ;#  set reset WAVE DMA
     WriteAIDARegister 0x700 0        ;#  and clear

#    disable WAVE capture

     WriteAIDARegister 0xa00 0x0000 ;#   disable readout
     WriteAIDARegister 0xa08 0      ;#   source select
     WriteAIDARegister 9 0x000d     ;#   reset 
     WriteAIDARegister 9 0x0000     ;#   clear resets

     WriteAIDARegister 0xa00 0x80 ;#   set reset the transfer and Time fifo for V8
     WriteAIDARegister 0xa00 0x00 ;#   unset reset the transfer and Time fifo for V8

     WriteAIDARegister 0xa00 0x8000 ;#   set RDO_reset
     WriteAIDARegister 0xa00 0x0000 ;#   unset RDO_reset

#    check ADCs are calibrated 

    if {[set ::AIDA::TestMode] == 0} {
	  set val [ReadAIDARegister 0x803]   ;# calibrate status register
	  if { $val == 0xf7 } {
		puts "ADCs Calibrated. " 
	  } else {
		puts "Warning : Status is : $val not 0xF7 "
		puts " ADCs NOT Calibrated. Check they are set for Calibrate pattern"
	  }
     } else {puts "Calibrate skipped in test mode"}

#     WriteAIDARegister 0x60a 0		; # set to data not test counter
#     WriteAIDARegister 0x308 0		; # set to data not test counter

     after 1000			 ; # Pause 1 second to allow the readout to settle

     WriteAIDARegister 0x600 1        ;#  enable ASIC DMA
 
     WriteAIDARegister 0x700 1        ;#  enable WAVE DMA

     WriteAIDARegister 0x300 0x0001   ;#  set enable ASIC readout

#     WriteAIDARegister 0xa00 0x0001   ;#  set enable WAVE readout

#     WriteAIDARegister 0x500 0x0001   ;#  set enable discriminators
#    WriteAIDARegister 0x310 1        ;#  enable MBS 23/5/16 moved from after enable ASIC DMA
     if {$Me == $TSMaster} {    
	  WriteAIDARegister 0x310 2 	;# output a RESET on the correlation interface
       	  WriteAIDARegister 0x310 0       ;#  Then remove the bit again....
     } 

#     WriteAIDARegister [expr 0x900 + 12 ]  0	;# start the wave form discriminators generating triggers

     after 5000 RDOGo_Operate

puts "Finished Go_Electronics for AIDA"

}

proc Reset_Merger {} {   ;#  used by RESET

    puts "executing Reset_Merger for AIDA"

    set rc [catch {Inform NewMerger doRestart} m]

}

 proc SpecSave1D {spec base range type title counts} {
    variable SpecPath

      set f3 [file join $SpecPath $spec.msf]
      set z1 [catch {open $f3 w} m1]
      set z2 [catch {file attributes $f3 -permissions rwxrwxrwx} m2]

      if {$z1 != 0} then {
          puts "Cannot create $f3 - $m1"
      }
      if {$z2 != 0} then {
          puts "error accessing $f3 - $m2"
      }

      set f $m1

      fconfigure $f -translation binary -encoding binary

  set ctime [clock format [clock seconds] -format {%d-%b-%Y %H:%M:%S}]
  set mtime [clock format [clock seconds] -format {%d-%b-%Y %H:%M:%S}]

      puts -nonewline $f [binary format i1 412900921]   ;#   magic number
      puts -nonewline $f [binary format i1 1]           ;#   version
      puts -nonewline $f [binary format a32 $spec]      ;#   spectrum name
      puts -nonewline $f [binary format i1 1]           ;#   dimension
      puts -nonewline $f [binary format a20 $ctime]     ;#   creation time/date
      puts -nonewline $f [binary format a20 $mtime]     ;#   modification time/date
      puts -nonewline $f [binary format i1 $base]       ;#   base0

      for {set i 2} {$i <=8} {incr i} {
         puts -nonewline $f [binary format i1 -1]     ;#   baseI
      }

      puts -nonewline $f [binary format i1 $range]    ;#   range0

      for {set i 2} {$i <=8} {incr i} {
         puts -nonewline $f [binary format i1 -1]     ;#   rangeI
      }

      puts -nonewline $f [binary format i1 -1]        ;#   spectrum title offset

      for {set i 2} {$i <=32} {incr i} {
         puts -nonewline $f [binary format i1 -1]     ;#  information pointers
      }

      for {set i 1} {$i <=8} {incr i} {
         puts -nonewline $f [binary format i1 -1]     ;#  annotation pointers
      }

      for {set i 1} {$i <=8} {incr i} {
         puts -nonewline $f [binary format i1 -1]     ;#  calibration pointers
      }

      for {set i 1} {$i <=8} {incr i} {
         puts -nonewline $f [binary format i1 -1]     ;#  efficiency pointers
      }

                                                     ;#  data array 1 descriptor 
      puts -nonewline $f [binary format i1 0]        ;#  array layout
      puts -nonewline $f [binary format i1 $type]    ;#  array type  (32 bit unsigned)
      puts -nonewline $f [binary format i1 0]        ;#  reserved 
      puts -nonewline $f [binary format i1 0]        ;#  reserved
      puts -nonewline $f [binary format i1 0]        ;#  spectrum counts offset

                                                     ;#  data array 2 descriptor 
      puts -nonewline $f [binary format i1 0]        ;#  array layout
      puts -nonewline $f [binary format i1 $type]    ;#  array type 
      puts -nonewline $f [binary format i1 0]        ;#  reserved 
      puts -nonewline $f [binary format i1 0]        ;#  reserved
      puts -nonewline $f [binary format i1 -1]       ;#  spectrum counts offset

      puts -nonewline $f [binary format i1 436]      ;#  base of string space
      puts -nonewline $f [binary format i1 20]       ;#  string free space
      puts -nonewline $f [binary format i1 76]       ;#  top of string space

      puts -nonewline $f [binary format i1 512]      ;#  base of counts space
      puts -nonewline $f [binary format i1 $range]   ;#  string free space
      puts -nonewline $f [binary format i1 $range]   ;#  top of string space
 
      puts -nonewline $f [binary format a20 $title]  ;# string space - title

      for {set i 456} {$i < 512} {incr i} {
         puts -nonewline $f [binary format c1 0]     ;#  unused
      }

      puts -nonewline $f [binary format i* $counts]  ;# counts

      close $f
}

    proc HistogramSave {{which "L"}} {
       variable SpecBase
       variable SpecPath

       set fname [file join / tmp HistogramSave.log]
       set z [catch {open $fname w} fid]
       if {$z != 0} {puts "Histogram Save logfile not created\n$fid\n"}

        puts "Saving $which Histograms"
        puts $fid "Saving $which Histograms at [clock format [clock seconds] -format "%B %d, %Y %H:%M:%S"]"

      set f1 $SpecBase
      set z1 [catch {file mkdir $f1} m1]
      set z2 [catch {file attributes $f1 -permissions rwxrwxrwx} m2]

#      if {$z1 != 0} then {
#          puts $fid "Cannot create $f1 - $m1"
#      }
#      if {$z2 != 0} then {
#          puts $fid "error accessing $f1 - $m2"
#      }

      set f1 [file join $f1 [exec uname -n]]
      set z1 [catch {file mkdir $f1} m1]
      set z2 [catch {file attributes $f1 -permissions rwxrwxrwx} m2]

#      if {$z1 != 0} then {
#          puts $fid "Cannot create $f1 - $m1"
#      }
#      if {$z2 != 0} then {
#          puts $fid "error accessing $f1 - $m2"
#      }

      set f2 [file join $f1 [date +%Y%h%d-%H.%M.%S]]
      set z1 [catch {file mkdir $f2} m1]
      set z2 [catch {file attributes $f2 -permissions rwxrwxrwx} m2]

      if {$z1 != 0} then {
          puts $fid "Cannot create $f2 - $m1"
      }
      if {$z2 != 0} then {
          puts $fid "error accessing $f2 - $m2"
      }

       set SpecPath $f2

       set SpecNames [SpectrumNames]
       set NumSpec 0

      foreach item $SpecNames {
         if {[first $item] != 1} {continue}   ;#   not a 1D histogram !!

         if {[string first L $which] < 0} continue 

         set SpecName [second $item]
         set spec [last [split $SpecName .]]
         if {[string first $spec $which] < 0} continue;#         if {$spec == "W"} {continue}

         set info [SpectrumDetails $SpecName]
         set channels [lindex $info 2]

         set title [SpectrumGetTitle $SpecName]
         set counts [SpectrumRead1D $SpecName 0 $channels]

         set z [catch {SpecSave1D $SpecName 0 $channels 5 $title $counts} m]
         if {$z!=0} then {
             puts $fid "Error attempting to save spectrum $SpecName: $m"
         } else {
             incr NumSpec
         }
      }

        puts $fid "$NumSpec Histograms saved at [clock format [clock seconds] -format "%B %d, %Y %H:%M:%S"]"

        close $fid

    }

    proc HistogramZero {} {

       set SpecNames [SpectrumNames]
       set NumSpec 0

       ZeroSpectrum Stat
       incr NumSpec

      foreach item $SpecNames {
         if {[first $item] != 1} {continue}   ;#   not a 1D histogram !!

         set SpecName [second $item]

         ZeroSpectrum $SpecName
         incr NumSpec
      }

       puts "$NumSpec spectra zeroed"
    }


    proc TerminateExec {} {

        unmap_spectra
        DataAcqCommand 22 "Terminating DataAcq program" 0 2

    }

    proc LoadExec {} {
       global Options
       global env

       set f [file join $env(MIDASBASE) Data_Acq bin linux-ppc_4xx $Options(DataAcqPgm)]

       set z [catch {eval exec nice $f &} m]
       if {$z != 0} {puts "RunControl LoadExec from $f returned z=$z and $m"}

    }
 
    proc FlashPgm {} {
       global env

       set f [file join $env(MIDASBASE) Aida FlashPgm.csh]

       set z [catch {exec $f > /tmp/FlashPgm.log} m]

       if {$z != 0} {
		set file_name [file join / tmp FlashPgm.log]
		puts "RunControl FlashPgm from $f returned z=$z and $m"
         	set z [catch {open $file_name a} file_id]
		if { $z != 0 }  { puts "\nFile open failed $file_name :- $z" ; break }
         	puts $file_id "FAILED\nMessage :$m\n"
         	set z [catch {close $file_id } close_error]
	}

    }

    proc CollectInfo {} {
#puts "In CollectInfo : Transferring /proc/buddyinfo to /tmp/mybuddy.txt"
	set z [catch {exec cat /proc/buddyinfo > /tmp/mybuddy.txt} m]
       	if {$z != 0} {
		puts "RunControl CollectInfo returned z=$z and m=$m"
	}
    }

    proc RDOGo_Operate { } {

puts "In RDOGo_Operate: Enabled Correlation, ASIC and discriminator readout"
	set Me $::DataAcquisition::ACQSERVER
	set TSMaster $::AIDA::TSMaster

	WriteAIDARegister 0x307 0xf      ;# enable readout for all four of the ASICs
	WriteAIDARegister 0x500 0x0001   ;#  set enable discriminators	
	if {$Me == $TSMaster} {    
     		WriteAIDARegister 0x310 1       ;#  Enable readout for Correlation Scalar
	} 

     if {[ReadNetVar NetVar.DACQ.Cwaveenable] == 1} {
puts "Also in RDOGo_Operate: Enabled waveform readout"
             WriteAIDARegister 0xa00 0x0001             ;#  set enable WAVE readout
             WriteAIDARegister [expr 0x900 + 12 ]  0	;# start the wave form discriminators generating triggers
     }

    }

    make-UIregisters

    Set_Options



