
set ReWriteAIDARegister 9
set Q8_Transfer_reset 4
set Wcap_DMA_reset 8
set Q8_reset 1

set Q8_Base 0xA00
set Q8_Control 0
set Q8_Source_Select 8

set CAP_Base 0x900
set CAP_ADC1 0
set CAP_ADC2 2
set CAP_ADC3 4
set CAP_ADC4 6
set CAP_Size 8
set CAP_Pre_Trigger 9
set CAP_Force 10

set DM_Base 0x700
set DM_Control 0
set DM_State_Machines 1
set DM_Status 2
set DM_Block_Start 3
set DM_High_Water_Mark 4
set DM_Block_Low_Count 5
set DM_Block_High_Count 6
set DM_Mem_Size 9
set DM_Source_Select 10

# set up for this small block to test operation
# all the following are byte values
set MEM_Base 0x07400000
set High_Water_Mark 0x0007FFFF 
set Memory_Size     0x00100000
set delay [ expr 4 << 20 ]
set polarity [ expr 0 << 16 ] 
#set threshold 16184
set threshold 50

set Capture_Size  1020
set Pre_Trigger   16

## reset the discriminators
        WriteAIDARegister [ expr $CAP_Base + $CAP_ADC1 + 1 ] 0
        WriteAIDARegister [ expr $CAP_Base + $CAP_ADC2 + 1 ] 0
        WriteAIDARegister [ expr $CAP_Base + $CAP_ADC3 + 1 ] 0
        WriteAIDARegister [ expr $CAP_Base + $CAP_ADC4 + 1 ] 0
## disable the Q8

        WriteAIDARegister [ expr $Q8_Base + $Q8_Control ] 0
        WriteAIDARegister [ expr $Q8_Base + $Q8_Source_Select ] 0
        WriteAIDARegister $ReWriteAIDARegister [ expr $Q8_Transfer_reset | $Wcap_DMA_reset | $Q8_reset ]
        WriteAIDARegister $ReWriteAIDARegister 0
## reset the DMA
        WriteAIDARegister [ expr $DM_Base + $DM_Control ] 0x8000 
        WriteAIDARegister [ expr $DM_Base + $DM_Control ] 0

## set up the CAP discriminators and the capture parameters
        WriteAIDARegister [ expr $CAP_Base + $CAP_ADC1 ] [expr $delay + $polarity + $threshold ]
        WriteAIDARegister [ expr $CAP_Base + $CAP_ADC2 ] [expr $delay + $polarity + $threshold ]
        WriteAIDARegister [ expr $CAP_Base + $CAP_ADC3 ] [expr $delay + $polarity + $threshold ]
        WriteAIDARegister [ expr $CAP_Base + $CAP_ADC4 ] [expr $delay + $polarity + $threshold ]

        WriteAIDARegister [ expr $CAP_Base + $CAP_Size ] $Capture_Size 
        WriteAIDARegister [ expr $CAP_Base + $CAP_Pre_Trigger ] $Pre_Trigger 

        WriteAIDARegister [ expr $DM_Base + $DM_Source_Select ] 0
        WriteAIDARegister [ expr $DM_Base + $DM_Block_Start ] $MEM_Base
        WriteAIDARegister [ expr $DM_Base + $DM_High_Water_Mark ] $High_Water_Mark
        WriteAIDARegister [ expr $DM_Base + $DM_Mem_Size ] $Memory_Size
        InsertLog "Set up : Address $MEM_Base, HWM $High_Water_Mark, Memory Size $Memory_Size with test counter in Wcap DMA"
        InsertLog "Set up : Delay = 4 samples , negative going , threshold is $threshold, Capture_Size $Capture_Size"
## start the DMA then readout
        WriteAIDARegister [ expr $DM_Base + $DM_Control ] 1
## start the transfer
        WriteAIDARegister [ expr $Q8_Base + $Q8_Control ] 1
## enable the channels

        WriteAIDARegister [ expr $CAP_Base + $CAP_ADC1 + 1 ] 0xF
        WriteAIDARegister [ expr $CAP_Base + $CAP_ADC2 + 1 ] 0
        WriteAIDARegister [ expr $CAP_Base + $CAP_ADC3 + 1 ] 0
        WriteAIDARegister [ expr $CAP_Base + $CAP_ADC4 + 1 ] 0

##      WaitForUser "Force?"
##      WriteAIDARegister [ expr $CAP_Base + $CAP_Force ] 1
##      WriteAIDARegister [ expr $CAP_Base + $CAP_Force ] 0

    InsertLog "Complete without error!!"
