
#    Note:  This is loaded into the namespace  WAVE

# variable started 0

if {![info exists started]} {variable started 0}

if {$started != 0} {

     variable JS ""
     variable LogFlag

     if {$LogFlag == 1} {InsertLog "Last Updated: [clock format [clock seconds] -format "%B %d, %Y %H:%M:%S"]"}

    do_click
}

if {$started == 0} {           ;#  first time load code and define local variables
    set started 1

    variable ShowLogFlag 0

    variable LogText ""
    variable LogFlag 0
    variable LogCount 0

    variable JS ""

    variable allmodules 0

    foreach i {0 1 2 3 4 5 6 8 9 e f} {variable Opta0$i 0}
	for { set i 32 } { $i < 48 } { incr i } {
		variable LED_status$i "<font color=purple>Empty<\/font>"
		variable Old_LED_status$i 0
	}


   proc  show_variables {} {
       variable allmodules
	for { set i 32 } { $i < 35 } { incr i } {
		variable LED_status$i
		variable Old_LED_status$i
		InsertLog "$i : Old LED status = [ set Old_LED_status$i ] : Current LED Status = [ set LED_status$i ]"
	}

       InsertLog "FEE64 = $::AIDA::FEE64"
       InsertLog "all modules = $allmodules"
   }

   proc do_redisplay {} {

     foreach i {0 1 2 3 4 5 6 8 9 e f} {
        variable Opta0$i
        set Opta0$i [ReadAIDARegister [expr 0xa00 + 0x$i]]
     }
	for { set i 32 } { $i < 48 } { incr i } {
		variable LED_status$i
		variable Old_LED_status$i

		set val [ReadAIDARegister [expr 0x900 + $i ] ]
		set LED_status$i ""
		set Old_val [ set Old_LED_status$i ]
		foreach byte { 3 2 1 0 } {
			set val1 [ expr ( $val >> ( $byte * 8) ) & 255 ]
			set this_val [ expr ( ( $val1 & 0x18) << 1 ) +  ( $val1 & 7 ) ]
			set val2 [ expr ( $Old_val >> ( $byte * 8 ) ) & 255 ]
			set last_val [ expr ( ( $val2 & 0x18) << 1 ) +  ( $val2 & 7 ) ]
			if { $this_val == 2 } { 
				set color green 
			} else { 
				if { $this_val == $last_val && $this_val == 0 } {
					set color red 
				} else {
					set color blue 
				} 
			}
			append LED_status$i [ format "<font color=$color>%02X<\/font> " $this_val ]
		}
	}
   }
# bits 1 and 0 => CP_START, CP_PRTRIG, CP_TRIG_TRUE, CP_FULL , CP_WAIT

#bits 2 and 3 => RB_START ,RB_LOAD, RB_LOOP
   proc do_setOpta00 {i vl} {
      variable allmodules

      set BAK $::AIDA::FEE64   ;#   save

      foreach fee64 $::AIDA::ModuleMenu {
          if {$allmodules == 0 && $fee64 != $::AIDA::FEE64} continue

          set ::AIDA::FEE64 $fee64
          WriteAIDARegister [expr 0xa00 + $i] $vl
      }

      set ::AIDA::FEE64 $BAK   ;#   restore
   }

   proc  Reset_Readout {} {
      variable allmodules

      set BAK $::AIDA::FEE64   ;#   save

      foreach fee64 $::AIDA::ModuleMenu {
          if {$allmodules == 0 && $fee64 != $::AIDA::FEE64} continue

          set ::AIDA::FEE64 $fee64
          set reg_bak [ ReadAIDARegister 0xa00 ]  ;# get the current setting 
 	WriteAIDARegister [expr 0x900 + 12 ]  1	;# stop the wave form discriminators from generating triggers
          WriteAIDARegister 0xa00 0x80   ;# do the reset
		  WriteAIDARegister 9 4 ;# reset the waveform discriminators
		  WriteAIDARegister 9 0 
          WriteAIDARegister 0xa00 $reg_bak   ;# restore the previous          
	WriteAIDARegister [expr 0x900 + 12 ]  0	;# restart the wave form discriminators generating triggers
       }

      set ::AIDA::FEE64 $BAK   ;#   restore
   }

   proc  do_click {}  {
       variable cgidata
       variable started
       variable LogFlag
       variable ShowLogFlag

       set cgidata [ncgi::nvlist]

       if {$LogFlag == 1} {InsertLog "cgidata= ([llength $cgidata]) $cgidata"}

       if {[llength $cgidata] == 0} then {return}

       if {[llength $cgidata] < 2} then {
           InsertLog "CGI data is too short: $cgidata"
       } else {
           if {[lindex $cgidata 0] != "Widget"} then {
               InsertLog "Invalid CGI data: $cgidata"
           } else {

              set w [first [lindex $cgidata 1]]
              set vl [second [lindex $cgidata 1]]

               switch -glob $w {

                   RESET    {set started 0}
                   CLEAR    {EmptyLog}
                   ELOG     {PrintLog}
                   RELOAD   {}
                   VARIABLES {show_variables}

                   HIDE     {set ShowLogFlag 0}
                   SHOW     {set ShowLogFlag 1}
                   LOGON    {set LogFlag 1}
                   LOGOFF   {set LogFlag 0}

                   MODULE     {set ::AIDA::FEE64 $vl}
                   ALLMODULES {variable allmodules; set allmodules [expr ($allmodules + 1) & 1]}

                   OPTA00     {do_setOpta00 [second [lindex $cgidata 1]] [third [lindex $cgidata 1]]}
                   EXPERT   {$vl}

                   MainLog {}
                   undefined {}
                   default {InsertLog "unexpected CGI data:  $cgidata"}
               }
           }
        }
        do_redisplay
     }

}   ;# end of if {$started == 0}




